//Panasonic Elecric Works 2003-2011
//This program uses the MEWTOCOL #R (read commands) over ajax request

//Global variables / parameters
var iNumberOfRecords = 5;			//History: point of records to load in one request
var iSizeOfRecord = 5;				//History: point of data per record
var iMaxLines = 98;					//Max lines
var PLCreg = new Array(iNumberOfRecords*iSizeOfRecord); //Response data array (16 bit words or integers)

var iLoopInterval;					//Checks the transfer status and start the next download of data
var iWait = 1;							//Wait before repeat loading data
var iDataLoop;							//Selection of the trend line
var iLines;

var bDownloadOK;						//Handshake for data download
var iNotFirstTime;					//Work different in the first cycle
var XML_Data;							//Buffer for MEWTOCOL request command
var PLC_StationAddress = "EE";	//PLC MEWTOCOL station address ("EE", "01"..."64")
var AddressHistory="DT31535";//Full PLC address of first AddressHistory register
var DTAddressHistory;				//First AddressHistory address (DT area) calculated from AddressHistory
var bIsAreaDT;							//AddressHistory in DT or FL area
var zeroes="00000";					//For generating leading zeroes

var iSendAddress;						//Address (DT area) calculated from IEC buffer header
var sSendAddress="DT31530"; //Full PLC address of the first element of the destination

var sTime = "";
var sDate = "";
var sCode = "";
var sText = "";
var sNumber = "";

var iError = 0;
var ALARMS = 4;

//JavaScript started on page load
window.onload = function()
{
	var iLoop0;
	var iLoop1;

	bDownloadOK = 1;			//Start download
	iNotFirstTime = 0;		//At first start update immediately, later in one step
	iLoopInterval = 0;		//Task manager
	iDataLoop = 0;				//Data block selector
	iLines = iMaxLines-2;	//Max. lines to display

	DTAddressHistory = parseInt(AddressHistory.substring(2,AddressHistory.length));	//String "DT90054" --> 90054
	bIsAreaDT = AddressHistory.search(/^DT/);														// FL is -1
	XML_Data = GenerateRD(PLC_StationAddress, DTAddressHistory, iNumberOfRecords*iSizeOfRecord, bIsAreaDT);	//%01#RDD0019900204** --> XML_Data

	//$("ajaxButton_Trigger").onclick = function(){SetData();};	// Prepared for send operation

	interval = 500;
	//UpdateData(XML_Data);
	intT = setInterval(function(){CheckIntervall();},interval);	//Set update interval

}

function CheckIntervall()
{
	$("ajaxDebug1").innerHTML = iNotFirstTime;
	//$("ajaxDebug2").innerHTML = bDownloadOK;
	//$("ajaxDebug3").innerHTML = iDataLoop;
	//$("ajaxDebug4").innerHTML = iLoopInterval;

	iLoopInterval = iLoopInterval + 1;
	if (iLoopInterval >= iLines*iWait || bDownloadOK == 2)
	{
		iLoopInterval = 0;
		iDataLoop = 0;
		bDownloadOK = 1;	// Start again
	}
	if (bDownloadOK == 1)
	{
		if (iDataLoop < iLines)
		{
		bDownloadOK = 0;	// Reset flag to recognize errors
		XML_Data = GenerateRD(PLC_StationAddress, DTAddressHistory + iDataLoop * iSizeOfRecord, iNumberOfRecords * iSizeOfRecord, bIsAreaDT); //%01#RDD0019900204** --> XML_Data
		UpdateData(XML_Data);	// Request new data
		}
		else{				// List completed
		iDataLoop = 0;
		iNotFirstTime = iNotFirstTime + 1;
		sTime = "";
		sDate = "";
		sCode = "";
		sText = "";
		sNumber = "";
		}
	}
}


// This function checks the status of the xhr object and calls the corresponding routines to
// display the variables
function DisplayPLCdata()
{
	var iIndex;
	var rxHor;
	var rxMin;
	var rxSec;
	var rxDay;
	var rxMon;
	var rxYar;
	var rxCode;
	var rxCode2;
	var iAlarm;
	var iStation;
	//const ALARMS = 4;

	if(xhr.readyState == XHR_READYSTATE_COMPLETED)
	{
		if (xhr.status == XHR_STATUS_OK) {
			try {
				if (XML_Data.indexOf(".xml") > 0)
					plc = eval("(" + xhr.responseText + ")");//Get PLC data
				else
					decodeRD_BCD(xhr.responseText); //RD response string, true=integer false=word
			}
			catch (e) {
				doError(e + "\nPLC or JSON read error.");
				return;
			}

			for (var iLoop = 0; iLoop < iNumberOfRecords; iLoop++) {
				iIndex = iLoop * iSizeOfRecord;
				rxHor = PLCreg[iIndex + 1].substring(2, 4);
				rxMin = PLCreg[iIndex + 0].substring(0, 2);
				rxSec = PLCreg[iIndex + 0].substring(2, 4);
				rxDay = PLCreg[iIndex + 1].substring(0, 2);
				rxMon = PLCreg[iIndex + 2].substring(2, 4);
				rxYar = PLCreg[iIndex + 2].substring(0, 2);
				rxCode = parseInt(PLCreg[iIndex + 3], 16);

				sTime = sTime + rxHor + ":" + rxMin + ":" + rxSec + "<br>&nbsp;";
				sDate = sDate + rxDay + "." + rxMon + "." + rxYar + "<br>&nbsp;";
				sCode = sCode + rxCode + "<br>&nbsp;";
				sNumber = sNumber + iDataLoop + "<br>&nbsp;";

				if (rxCode < 256)
				{
					switch (rxCode) {
						case 0:
							sText = sText + ".<br>&nbsp;";
							break;
						case 1:
							sText = sText + "SPS: Neustart<br>&nbsp;";
							break;
						case 2:
							sText = sText + "SPS: Onlineprogrammierung erkannt<br>&nbsp;";
							break;
						case 3:
							sText = sText + "IEC60870: Puffer 1 Neustart<br>&nbsp;";
							break;
						case 4:
							sText = sText + "IEC60870: Puffer 2 Neustart<br>&nbsp;";
							break;
						case 10:
							sText = sText + "SPS: Hardwarefehler<br>&nbsp;";
							break;
						case 11:
							sText = sText + "SPS: Intelligent unit hw error<br>&nbsp;";
							break;
						case 12:
							sText = sText + "SPS: Verify error I/O unit<br>&nbsp;";
							break;
						case 13:
							sText = sText + "SPS: Constant cycle alarm<br>&nbsp;";
							break;
						case 42:
							sText = sText + "SPS: Selbstdiagnosefehler<br>&nbsp;";
							break;
						case 45:
							sText = sText + "SPS: Operationsfehler<br>&nbsp;";
						break;
						case 50:
							sText = sText + "SPS: Batteriefehler<br>&nbsp;";
							break;
						case 232:
							sText = sText + "SPS: Fehler in serieller Schnittstelle<br>&nbsp;";
							break;
						default:
							sText = sText + "Unbekannter Fehler<br>&nbsp;";
							break;
					}
				}
				else	// Additional messages for the GPRS-LinkManager 
				{
					rxCode = rxCode - 10000;
					rxCode2 = rxCode % 100;
					iStation = (rxCode - rxCode2) / 100;
					sText = sText + "Station ";
					if (rxCode2 >= ALARMS)
					{
						iAlarm = Math.floor((rxCode2 - ALARMS)/2);
						rxCode2 = rxCode2%2+ALARMS; // alarm on: rxCode is a odd value
					}
					else
					{
						iAlarm = 0;
					}
					switch (rxCode2) {
						case 0:
							sText = sText + iStation + ": Offline<br>&nbsp;";
							break;
						case 1:
							sText = sText + iStation + ": Verbunden<br>&nbsp;";
						break;
						case 2:
							sText = sText + iStation + ": Keine Daten<br>&nbsp;";
							break;
						case 3:
							sText = sText + iStation + ": Fehlerfreier Datenaustausch<br>&nbsp;";
							break;
						case ALARMS:
							sText = sText + iStation + ": Alarm " + iAlarm + ": geht<br>&nbsp;";
							break;
						case ALARMS+1:
							sText = sText + iStation + ": Alarm " + iAlarm + ": kommt<br>&nbsp;";
							break;
						default:
							sText = sText + "unknown coded error<br>&nbsp;";
							break;
					}
					
				}
				
				iDataLoop = iDataLoop + 1;
			} //end for

			if (rxCode == 0)	// Stop in case of no more error messages
				iDataLoop = iLines+1;

			if (iNotFirstTime == 0 || iDataLoop >= iLines) {
				$("ajaxTime").innerHTML = sTime;
				$("ajaxDate").innerHTML = sDate;
				$("ajaxErrorNumber").innerHTML = sCode;
				$("ajaxMessage").innerHTML = sText;
				$("ajaxNumber").innerHTML = sNumber;
			}
			iError = 0; // read ready
			bDownloadOK = 1;
		}//end if XHR_STATUS_OK
		else
		{
			iError = iError + 1; // read error
			if (iError > 5) {
				iError = 0; // error reset
				alert("Message returned, but with error status.");
			}
			bDownloadOK = 2;
		}//end else
	}//end if XHR_READYSTATE_COMPLETED
}


// This function reads the value entered in the formular field and assigns it to the correspong DTs
function SetData(iMode) // Prepared for send operation
{
	// get the address of the buffer
	iSendAddress = parseInt(sSendAddress.substring(2,sSendAddress.length));	//String e.g. "DT90054" --> 90054
	// send the value to the actual address stored in iStationsCall
	//Activate if used: if (isNaN(iIEC870_RBM) != true)
	//Activate if used: SendDT(iIEC870_RBM, 0); // Send out...
}
/* End of file */